unit Editor6_f;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls, Menus, ToolWin, ImgList, Printers, StdActns,
  ActnList;

type
  TFormular = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Novy: TMenuItem;
    Otevrit: TMenuItem;
    Ulozit: TMenuItem;
    Ulozitjako: TMenuItem;
    N1: TMenuItem;
    Konec: TMenuItem;
    Pismo: TMenuItem;
    Font1: TMenuItem;
    N2: TMenuItem;
    podtrzene: TMenuItem;
    Tucne: TMenuItem;
    Kurziva1: TMenuItem;
    Napoveda1: TMenuItem;
    Oprogramu1: TMenuItem;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Upravy: TMenuItem;
    lamani: TMenuItem;
    Vybratvse: TMenuItem;
    Barva: TMenuItem;
    ColorDialog1: TColorDialog;
    panelNastroju: TToolBar;
    NovyTl: TToolButton;
    OtevritTl: TToolButton;
    UlozitTl: TToolButton;
    UlozitJakoTl: TToolButton;
    ToolButton5: TToolButton;
    FontTl: TToolButton;
    BarvaTl: TToolButton;
    ToolButton8: TToolButton;
    ObrazkyProTlac: TImageList;
    TucneTl: TToolButton;
    kurzTl: TToolButton;
    PodtrzeneTl: TToolButton;
    ToolButton11: TToolButton;
    UpravyTl: TToolButton;
    oprgramuTl: TToolButton;
    ToolButton14: TToolButton;
    stavovyradek: TStatusBar;
    TiskTl: TToolButton;
    Tisk: TMenuItem;
    N3: TMenuItem;
    Tiskarna: TPrintDialog;
    ActionList1: TActionList;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    N4: TMenuItem;
    Koprovat1: TMenuItem;
    Vyjmout1: TMenuItem;
    Vloit1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    procedure KonecClick(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure FontDialog1Apply(Sender: TObject; Wnd: HWND);
    procedure podtrzeneClick(Sender: TObject);
    procedure PismoClick(Sender: TObject);
    procedure TucneClick(Sender: TObject);
    procedure Kurziva1Click(Sender: TObject);
    procedure NovyClick(Sender: TObject);
    procedure OtevritClick(Sender: TObject);
    procedure UlozitClick(Sender: TObject);
    procedure UlozitjakoClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure lamaniClick(Sender: TObject);
    procedure VybratvseClick(Sender: TObject);
    procedure Oprogramu1Click(Sender: TObject);
    procedure BarvaClick(Sender: TObject);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TiskClick(Sender: TObject);
  private
    JmenoSouboru:string;
    Zmeneno:Boolean;
    { Private declarations }
  public
    function Uloz(soubor:String):boolean;
    function UlozJako(var soubor:String):Boolean;
    Procedure ShowHint(sender:TObject);
    { Public declarations }
  end;

var
  Formular: TFormular;

implementation

uses About_f;

{$R *.DFM}

procedure TFormular.KonecClick(Sender: TObject);
begin
  Close;
end;

procedure TFormular.Font1Click(Sender: TObject);
begin
  FontDialog1.Options:=FontDialog1.Options+[fdApplyButton]; //pidn tlatka pout
  if FontDialog1.Execute then //zobrazen dialogovho okna
    RichEdit1.SelAttributes.Assign(FontDialog1.Font); //nastaven vlastnost psma
end;

procedure TFormular.FontDialog1Apply(Sender: TObject; Wnd: HWND);
begin
  RichEdit1.SelAttributes.Assign(FontDialog1.Font);  //nastaven vlastnost psma
end;

procedure TFormular.podtrzeneClick(Sender: TObject);
begin
  if not (fsUnderline in RichEdit1.SelAttributes.Style)then
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style +[fsUnderline]
  else
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style -[fsUnderline];
end;


procedure TFormular.TucneClick(Sender: TObject);
begin
  if not (fsBold in RichEdit1.SelAttributes.Style) then
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style +[fsBold]
  else
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style -[fsBold];
end;


procedure TFormular.Kurziva1Click(Sender: TObject);
begin
  if not (fsItalic in RichEdit1.SelAttributes.Style)then
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style +[fsItalic]
  else
   RichEdit1.SelAttributes.Style:=RichEdit1.SelAttributes.Style -[fsItalic];
end;


procedure TFormular.PismoClick(Sender: TObject);
//nastaven znaky v menu.
begin
 Podtrzene.Checked:=fsUnderline in RichEdit1.SelAttributes.Style;
 Tucne.Checked:=fsBold in RichEdit1.SelAttributes.Style;
 Kurziva1.Checked:=fsItalic in RichEdit1.SelAttributes.Style;
end;


procedure TFormular.NovyClick(Sender: TObject);
begin
  if (Zmeneno) then  //pokud dolo ke zmn, mus se star soubor uloit.
    case MessageDlg('Uloit zmny?',
                                mtConfirmation,[mbYes,mbNo,mbCancel],0) of
      mrYes: if not Uloz(JmenoSouboru) then exit;  //uloit soubor pokud
                                                   //se neuloil konec
      mrCancel: exit; // zruit akci.
    end;

  RichEdit1.Lines.Clear; //smazn obsahu komponenty
  Zmeneno:=false;
  StavovyRadek.Panels[1].text:='';
  StavovyRadek.Panels[2].text:='';
  Jmenosouboru:='';
  Formular.Caption:='RTF Editor 6.0';
end;

procedure TFormular.OtevritClick(Sender: TObject);
begin
  if OpenDialog1.Execute then    //vbr jmna souboru
    begin
      JmenoSouboru:=OpenDialog1.FileName;
      RichEdit1.Lines.LoadFromFile(JmenoSouboru); //nahrni souboru
      Zmeneno:=False;
      Formular.Caption:='RTF Editor 6.0 - '+ jmenoSouboru; //prava titulku
      StavovyRadek.Panels[1].text:='';
      StavovyRadek.Panels[2].text:=JmenoSouboru;
    end;
end;

procedure TFormular.UlozitClick(Sender: TObject);
begin
  if JmenoSouboru<>'' then Uloz(JmenoSouboru)
    else UlozJako(JmenoSouboru);
end;

procedure TFormular.UlozitjakoClick(Sender: TObject);
begin
  UlozJako(JmenoSouboru);
end;

procedure TFormular.RichEdit1Change(Sender: TObject);
begin
  if not zmeneno then
    begin
      zmeneno:=True;  //dolo k njak zmn
      StavovyRadek.Panels[1].text:='Zmnno';
    end
end;

procedure TFormular.lamaniClick(Sender: TObject);
begin
  if not lamani.Checked then
    begin
      RichEdit1.WordWrap:=true;   //nastavit lmn dek
      RichEdit1.ScrollBars:=ssVertical; //zruit horizontln posuvnk
    end
  else
    begin
      RichEdit1.WordWrap:=false; //zruit lmn dek
      RichEdit1.ScrollBars:=ssBoth; //pidat horizontln posuvnk
    end;
  lamani.Checked:=not Lamani.Checked;

end;

procedure TFormular.VybratvseClick(Sender: TObject);
begin
  RichEdit1.SelStart:=0;  //oznaen celho textu.
  RichEdit1.SelLength:=Length(RichEdit1.Text);
end;

procedure TFormular.Oprogramu1Click(Sender: TObject);
begin
  About.ShowModal;
end;

procedure TFormular.BarvaClick(Sender: TObject);
begin
  If ColorDialog1.Execute then  //vbr barvy pomoc dialogovho okna
    RichEdit1.SelAttributes.Color:=ColorDialog1.Color;
end;

function TFormular.Uloz(Soubor:String):Boolean;
begin
  RichEdit1.Lines.SaveToFile(Soubor); //uloen souboru
  zmeneno:=false;//soubor je ji uloen
  StavovyRadek.Panels[1].text:='';
  StavovyRadek.Panels[2].text:=JmenoSouboru;
  result:=true;
end;

function TFormular.UlozJako(var Soubor:String):boolean;
begin
  SaveDialog1.FileName:=Soubor;
  if SaveDialog1.Execute then
       JmenoSouboru:=SaveDialog1.FileName //vbr jmna souboru
   else
     begin
       Result:=false;
       exit; //stisknuto tlatko zruit -> konec
     end;
  Result:=Uloz(Soubor);
  Formular.Caption:='RTF Editor 6.0 - '+Soubor; //prava titulku
end;

procedure TFormular.RichEdit1SelectionChange(Sender: TObject);
begin
 TucneTl.Down:=fsBold in RichEdit1.SelAttributes.Style;
 KurzTl.Down:=fsItalic in RichEdit1.SelAttributes.Style;
 PodtrzeneTl.Down:=fsUnderline in RichEdit1.SelAttributes.Style;
end;

procedure TFormular.FormCreate(Sender: TObject);
begin
  Application.OnHint:=ShowHint;
end;

Procedure TFormular.ShowHint(Sender:TObject);
begin
  StavovyRadek.Panels[0].text:=Application.Hint;
end;

procedure TFormular.TiskClick(Sender: TObject);
begin
  if tiskarna.execute then
      RichEdit1.Print(JmenoSouboru);
end;
end.
